from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.GeologicTimeScale.config import PROJECTNAME, GLOBALS

from StringIO import StringIO

def install(self):
    out = StringIO()

    installTypes(self, out, listTypes(PROJECTNAME), PROJECTNAME)

    install_subskin(self, out, GLOBALS)

    ##
    ## Register GeologicTimeScale as folderish content in plone, so it will
    ## get the appropriate folder_contents tabs
    props = self.portal_properties.site_properties
    tabs = getattr(props, 'use_folder_tabs')
    contents = getattr(props, 'typesLinkToFolderContentsInFC')

    if 'GeologicTimeScale' not in tabs:
        newtabs = list(tabs)
        newtabs.append('GeologicTimeScale')
        props._updateProperty('use_folder_tabs', newtabs)

    if 'GeologicTimeScale' not in contents:
        newcontents = list(contents)
        newcontents.append('GeologicTimeScale')
        props._updateProperty('typesLinkToFolderContentsInFC', newcontents)

    out.write("Successfully installed %s." % PROJECTNAME)
    return out.getvalue()
